﻿// //////////////////////////////////////////////////////////////////////////
//
// uuids.cs
//              Sarbo Project
//          Powerd by CACTUS SOFTWARE <http://www.cactussoft.co.jp/>
//
//                                              ver 1.0  2009/08/15
// This file is part of Sarbo.
//
// Sarbo is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// Sarbo is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Sarbo.  If not, see <http://www.gnu.org/licenses/>.
//
// //////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace DShowCAC
{
	// //////////////////////////////////////////////////////////////////////
	// CLSID

	[ComVisible(false)]
	public class CLSID
	{
		public static readonly Guid SystemDeviceEnum = new Guid(
			0x62BE5D10, 0x60EB, 0x11d0, 0xBD, 0x3B, 0x00, 0xA0, 0xC9, 0x11, 0xCE, 0x86);

		public static readonly Guid FilterGraph = new Guid(
			0xe436ebb3, 0x524f, 0x11ce, 0x9f, 0x53, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70);

		public static readonly Guid FilterMapper = new Guid(
			0xe436ebb2, 0x524f, 0x11ce, 0x9f, 0x53, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70);

		public static readonly Guid FilterMapper2 = new Guid(
			0xcda42200, 0xbd88, 0x11d0, 0xbd, 0x4e, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid CaptureGraphBuilder = new Guid(
			0xBF87B6E0, 0x8C27, 0x11d0, 0xB3, 0xF0, 0x00, 0xAA, 0x00, 0x37, 0x61, 0xC5);

		public static readonly Guid CaptureGraphBuilder2 = new Guid(
			0xBF87B6E1, 0x8C27, 0x11d0, 0xB3, 0xF0, 0x00, 0xAA, 0x00, 0x37, 0x61, 0xC5);

		public static readonly Guid CaptureProperties = new Guid(
			0x1B544c22, 0xFD0B, 0x11ce, 0x8C, 0x63, 0x00, 0xAA, 0x00, 0x44, 0xB5, 0x1F);

		public static readonly Guid DvdGraphBuilder = new Guid(
			0xFCC152B7, 0xF372, 0x11d0, 0x8E, 0x00, 0x00, 0xC0, 0x4F, 0xD7, 0xC0, 0x8B);

		public static readonly Guid WMAsfReader = new Guid(
			0x187463a0, 0x5bb7, 0x11d3, 0xac, 0xbe, 0x00, 0x80, 0xc7, 0x5e, 0x24, 0x6e);

		public static readonly Guid WMAsfWriter = new Guid(
			0x7c23220e, 0x55bb, 0x11d3, 0x8b, 0x16, 0x00, 0xc0, 0x4f, 0xb6, 0xbd, 0x3d);

		public static readonly Guid AsyncReader = new Guid(
			0xe436ebb5, 0x524f, 0x11ce, 0x9f, 0x53, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70);

//CLSID_AsyncSample

		public static readonly Guid SampleGrabber = new Guid(
			0xC1F400A0, 0x3F08, 0x11D3, 0x9F, 0x0B, 0x00, 0x60, 0x08, 0x03, 0x9E, 0x37);

		public static readonly Guid VideoMixingRenderer = new Guid(
			0xB87BEB7B, 0x8D29, 0x423f, 0xAE, 0x4D, 0x65, 0x82, 0xC1, 0x01, 0x75, 0xAC);

		public static readonly Guid VideoMixingRenderer9 = new Guid(
			0x51b4abf3, 0x748f, 0x4e3b, 0xa2, 0x76, 0xc8, 0x28, 0x33, 0x0e, 0x92, 0x6a);

		public static readonly Guid DSoundRender = new Guid(
			0x79376820, 0x07D0, 0x11CF, 0xA2, 0x4D, 0x00, 0x20, 0xAF, 0xD7, 0x97, 0x67);

		public static readonly Guid DVVideoCodec = new Guid(
			0xb1b77c00, 0xc3e4, 0x11cf, 0xaf, 0x79, 0x00, 0xaa, 0x00, 0xb6, 0x7a, 0x42);

		public static readonly Guid DVVideoEnc = new Guid(
			0x13aa3650, 0xbb6f, 0x11d0, 0xaf, 0xb9, 0x00, 0xaa, 0x00, 0xb6, 0x7a, 0x42);

		public static readonly Guid DVMux = new Guid(
			0x129d7e40, 0xc10d, 0x11d0, 0xaf, 0xb9, 0x00, 0xaa, 0x00, 0xb6, 0x7a, 0x42);

		public static readonly Guid DVMuxPropertyPage = new Guid(
			0x4db880e0, 0xc10d, 0x11d0, 0xaf, 0xb9, 0x00, 0xaa, 0x00, 0xb6, 0x7a, 0x42);

		public static readonly Guid DVEncPropertiesPage = new Guid(
			0x4150f050, 0xbb6f, 0x11d0, 0xaf, 0xb9, 0x00, 0xaa, 0x00, 0xb6, 0x7a, 0x42);

		public static readonly Guid DVSplitter = new Guid(
			0x4eb31670, 0x9fc6, 0x11cf, 0xaf, 0x6e, 0x00, 0xaa, 0x00, 0xb6, 0x7a, 0x42);

		public static readonly Guid FileSource = new Guid(
			0x701722e0, 0x8ae3, 0x11ce, 0xa8, 0x5c, 0x00, 0xaa, 0x00, 0x2f, 0xea, 0xb5);

		public static readonly Guid FileWriter = new Guid(
			0x8596e5f0, 0x0da5, 0x11d0, 0xbd, 0x21, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid Gargle = new Guid(
			0xd616f350, 0xd622, 0x11ce, 0xaa, 0xc5, 0x00, 0x20, 0xaf, 0x0b, 0x99, 0xa3);

		public static readonly Guid GargProp = new Guid(
			0xd616f351, 0xd622, 0x11ce, 0xaa, 0xc5, 0x00, 0x20, 0xaf, 0x0b, 0x99, 0xa3);

		public static readonly Guid InfTee = new Guid(
			0xf8388a40, 0xd5bb, 0x11d0, 0xbe, 0x5a, 0x00, 0x80, 0xc7, 0x06, 0x56, 0x8e);

//CLSID_MultiVMR9MixerControl
//CLSID_MultiVMR9RenderEngine
//CLSID_MultiVMR9UILayer
//CLSID_MultiVMR9Wizard

		public static readonly Guid TextRender = new Guid(
			0xe30629d3, 0x27e5, 0x11ce, 0x87, 0x5d, 0x00, 0x60, 0x8c, 0xb7, 0x80, 0x66);

//CLSID_TextureRenderer

		public static readonly Guid AviSplitter = new Guid(
			0x1b544c20, 0xfd0b, 0x11ce, 0x8c, 0x63, 0x00, 0xaa, 0x00, 0x44, 0xb5, 0x1e);

		public static readonly Guid CWaveinClassManager = new Guid(
			0x33d9a762, 0x90c8, 0x11d0, 0xbd, 0x43, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid CWaveOutClassManager = new Guid(
			0xe0f158e1, 0xcb04, 0x11d0, 0xbd, 0x4e, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid DirectDraw = new Guid(
            0xD7B70EE0, 0x4340, 0x11CF, 0xB0, 0x63, 0x00, 0x20, 0xAF, 0xC2, 0xCD, 0x35);

		public static readonly Guid DirectDrawClipper = new Guid(
			0x593817A0, 0x7DB3, 0x11CF, 0xA2, 0xDE, 0x00, 0xAA, 0x00, 0xb9, 0x33, 0x56);

		public static readonly Guid DirectDrawProperties = new Guid(
			0x944d4c00, 0xdd52, 0x11ce, 0xbf, 0x0e, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a);

//CLSID_DSNetSend
//CLSID_DSNetReceive

		// //////////////////////////////////////////////////////////////////
		// Category

		public static readonly Guid VideoInputDeviceCategory = new Guid(
			0x860BB310, 0x5D01, 0x11d0, 0xBD, 0x3B, 0x00, 0xA0, 0xC9, 0x11, 0xCE, 0x86);

		public static readonly Guid VideoCompressorCategory = new Guid(
			0x33d9a760, 0x90c8, 0x11d0, 0xbd, 0x43, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid ActiveMovieCategories = new Guid(
			0xda4e3da0, 0xd07d, 0x11d0, 0xbd, 0x50, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid AudioInputDeviceCategory = new Guid(
			0x33d9a762, 0x90c8, 0x11d0, 0xbd, 0x43, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid AudioRendererCategory = new Guid(
			0xe0f158e1, 0xcb04, 0x11d0, 0xbd, 0x4e, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid AudioCompressorCategory = new Guid(
			0x33d9a761, 0x90c8, 0x11d0, 0xbd, 0x43, 0x00, 0xa0, 0xc9, 0x11, 0xce, 0x86);

		public static readonly Guid MidiRendererCategory = new Guid(
			0x4EfE2452, 0x168A, 0x11d1, 0xBC, 0x76, 0x00, 0xc0, 0x4F, 0xB9, 0x45, 0x3B);

		public static readonly Guid DeviceControlCategory = new Guid(
			0xcc7bfb46, 0xf175, 0x11d1, 0xa3, 0x92, 0x00, 0xe0, 0x29, 0x1f, 0x39, 0x59);
	}

	// //////////////////////////////////////////////////////////////////////
	// MEDIATYPE

	[ComVisible(false)]
	public class MediaType
	{
		public static readonly Guid Video = new Guid(
			0x73646976, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);

		public static readonly Guid Audio = new Guid(
			0x73647561, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);

		public static readonly Guid Midi = new Guid(
			0x7364696D, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);

		public static readonly Guid Stream = new Guid(
			0xe436eb83, 0x524f, 0x11ce, 0x9f, 0x53, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70);
	}

	// //////////////////////////////////////////////////////////////////////
	// FORMAT

	[ComVisible(false)]
	public class Format
	{
		public static readonly Guid None = new Guid(
			0x0F6417D6, 0xc318, 0x11d0, 0xa4, 0x3f, 0x00, 0xa0, 0xc9, 0x22, 0x31, 0x96);

		public static readonly Guid VideoInfo = new Guid(
			0x05589f80, 0xc356, 0x11ce, 0xbf, 0x01, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a);

		public static readonly Guid VideoInfo2 = new Guid(
			0xf72a76A0, 0xeb0a, 0x11d0, 0xac, 0xe4, 0x00, 0x00, 0xc0, 0xcc, 0x16, 0xba);

		public static readonly Guid WaveFormatEx = new Guid(
			0x05589f81, 0xc356, 0x11ce, 0xbf, 0x01, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a);

		public static readonly Guid MPEGVideo = new Guid(
			0x05589f82, 0xc356, 0x11ce, 0xbf, 0x01, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a);

		public static readonly Guid MPEGStreams = new Guid(
			0x05589f83, 0xc356, 0x11ce, 0xbf, 0x01, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a);

		public static readonly Guid DvInfo = new Guid(
			0x05589f84, 0xc356, 0x11ce, 0xbf, 0x01, 0x00, 0xaa, 0x00, 0x55, 0x59, 0x5a);
	}
	// more: see uuids.h
}

// //////////////////////////////////////////////////////////////////////////
